/**
 * @file Distribute apeman-ui-contrib-angular-storaging.
 */

"use strict";

var argx = require('argx'),
    async = require('async'),
    path = require('path'),
    concatFiles = require('apeman-commons-compiling/lib/concat_files'),
    objnest = require('objnest');

/** @lends apemanUiContribAngularStoraging */
function apemanUiContribAngularStoraging(context, values, options, callback) {
    var args = argx(arguments);
    context = args.shift('object') || {};
    callback = args.pop('function') || argx.noop;
    options = objnest.expand(args.pop('object') || {});
    values = args.remain();

    var logger = context.logger,
        dest = options.dest || 'apeman-ui';

    async.series([
        function (callback) {
            var filename = path.resolve(dest, 'apeman-ui-contrib-angular-storaging.js');
            concatFiles([
                path.resolve(__dirname, 'assets/src/module.js'),
                path.resolve(__dirname, 'assets/src/**/*.js')
            ], filename, {
                unique: true
            }, function (err, result) {
                if (!err) {
                    if (!result.skipped) {
                        logger.debug('File generated:', filename);
                    }
                }
                callback(err);
            });
        }
    ], callback);


}

module.exports = apemanUiContribAngularStoraging;
